/**
*	driver application that tests the City class
*
*	@author: D. Slater
*	@version: 3/31/2003
*/

import java.io.*;
import java.util.*;

public class Cities {

	public static void main(String args[]) throws IOException {
	
		// open the file
		BufferedReader file = new BufferedReader(new FileReader(new File("cities.txt")));
		
		// create the City collection
		CityList cities = new CityList(5);
		
		// build the collection from the file
		String str;
		
		while ( (str = file.readLine()) != null) {					// get line from file
			StringTokenizer stk = new StringTokenizer(str);		// get the components
			String cName = stk.nextToken();					// of city from the line
			int cPop = Integer.parseInt(stk.nextToken());
			double cArea = Double.parseDouble(stk.nextToken());
			
			City cty = new City(cName, cPop, cArea);			// build a City object
			
			cities.add(cty);									// add the object to collection
		}
		

		System.out.println();
		System.out.println("The unordered list of Cities: ");
		cities.printList();
		System.out.println();
		
		cities.selectionSort();

		System.out.println();
		System.out.println("The ordered list of Cities: ");
		cities.printList();
		System.out.println();
		
		

		System.out.println("Search for Pittsburgh: ");
		System.out.println("Pittsburgh at position: " + cities.binarySearch("Pittsburgh"));
		System.out.println();
		System.out.println("Search for Fargo: ");
		System.out.println("Fargo at position: " + cities.binarySearch("Fargo"));
		System.out.println();

	}
}
