/**
 *	Models a Phrase for recursive manipulation
 *
 *	@author D. Slater
 *	@version 9/27/2003
 */
 
 
 public class Phrase {
 
 	// instance variable
 	private String phrase;
 	
 	/**
 	 *	constructs an empty Phrase
 	 */
 	 
 	 public Phrase() {
 	 
 	 	phrase = "";
 	 }
 	 
 	 /**
 	  *	constructs a Phrase with the String argument
 	  *	@param String phr - the String used to construct the phrase
 	  */
 	  
 	  public Phrase(String phr) {
 	  
 	  	phrase = phr;
 	  }
 	  
 	  /**
 	   *	Builds a String from the phrase with a space between each character
 	   */
 	   
 	   public String split() {
 	   
 	   	return split(phrase);
 	   }
 	   
 	   private String split(String phr) {
 	   
 	   	if (phr.equals("")) {
 	   		return "";
 	   	} else {
 	   	 	return phr.charAt(0) + " " + split(phr.substring(1));
 	   	 }
 	   }
 	   
 	   
 	  /**
 	   *	Builds a String from the phrase with each character doubled
 	   */
 	   
 	   public String repeat() {
 	   
 	   	return repeat(phrase);
 	   }
 	   
 	   private String repeat(String phr) {
 	   
 	   	if (phr.equals("")) {
 	   		return "";
 	   	} else {
 	   	 	return phr.charAt(0) + "" + phr.charAt(0)  + repeat(phr.substring(1));
 	   	 }
 	   }
 	   
 	  /**
 	   *	Builds a String from the phrase in which the phrase is reversed
 	   */
 	   
 	   public String reverse() {
 	   
 	   	return reverse(phrase);
 	   }
 	   
 	   private String reverse(String phr) {
 	   
 	   	if (phr.equals("")) {
 	   		return "";
 	   	} else {
 	   	 	return reverse(phr.substring(1)) + "" + phr.charAt(0);
 	   	 }
 	   }
 	   
 	   /**
 	   *	Returns the String version of this phrase
 	   */
 	   
 	   public String toString() {
 	   
 	   	return phrase;
 	   }
 }