/** 
 * Walker.java
 *
 * Title:	RandomWalker Demo		
 * Description:	This robot has it's own "coin" to randomly generate its
 *		next move. chooses its next step and moves there if the path is not blocked,
 *		as well as how many steps it took.
 *
 * 
 * @author		Slater		
 * @version			
 */


package kareltherobot;

import java.util.*;


class Walker extends BetterRobot implements WalkerRobot
{

	static private Random coin = new Random();
	private int startAve, startStr, numSteps;

	/**
	*	constructor initially sets up using the parent c'tor, then initializes
	*	the Walker-specific state (starting position and number of steps)
	*/ 
	public Walker(int street, int avenue, Directions.Direction direction, int howmany) 
	{

		super(street, avenue, direction, howmany);
		startStr = street;
		startAve = avenue;
		numSteps = 0;
	}

	/**
	*	THIS METHOD WILL BE MODIFIED FOR HW 7
	*
	* 	Allows the robot to choose its path, as well as modify its position
	*	and update the number of steps. It will also prevent the robot
	*	from running into a wall
	*
	*	1) have the coin object return a value from 0 .. 3 by modifying the nextInt parameter
	*	2) a flip value of 1 should faceSouth, a flip value of 2 should faceWest, and a
	*          flip value of 3 should faceNorth... Modify the if .. else statement accordingly
	*/	
	public void takeOneStep()
	{
		int flip  = coin.nextInt(2);			// modify to return possible values 0, 1, 2, or 3

		if (flip == 0) {					// modify to have the robot choose to face one of
			faceEast();				// the four compass directions
		} else {			
			faceWest();
		}

		if (frontIsClear()) {				// does not need to be modified
			super.move();
			numSteps++;
		}
	}

	/**
	*	THIS METHOD WILL BE MODIFIED FOR HW 7
	*
	*	Indicates that the robot has finished its task. Modify this so that the robot is finished once it is
	*	positioned on a corner next to a Beeper
	*/
	public boolean isFinished() {

		return numSteps >= 50;
	}


	/**	
	*	THIS METHOD WILL BE MODIFIED FOR HW 7
	*
	*	Modify this method to determine the distance of the robot from its starting position, 
	*	using the distance formula: 
	*	        the squareroot (use Math.sqrt()) of (the difference between the current
	*		street position and the startStr position squared + the difference
	*		between the current avenue position and the startAve position squared))
	*
	*	@return double distance between robot starting position and current position
	*/  	
	public double getDistance() {

		return Math.abs(avenue() - startAve);
	}

	/*	
	*	reports the total number of steps (numSteps instance variable) the robot has taken 
	*	since its construction
	*
	*	@return int number of steps taken by the robot
	*/  	
	public int getNumSteps() {

		return numSteps;
	}

}