 package kareltherobot;

import java.util.*;

public class Player extends BetterRobot implements GamePiece {

	private static Random rnd = new Random();
	
	public Player(int str, int ave, Directions.Direction dir, int howMany) {
	
		super(str, ave, dir, howMany);
	}
	
	public boolean isFinished() {
	
		return nextToABeeper();
	}
	
	private void slideOrClimb() {
	
		while (frontIsClear()) {
			move();
		}
		if (street() % 2 == 0) {
			faceWest();
		} else {
			faceEast();
		}
	}

	public void checkPosition() {
	
		int directionToCheck = rnd.nextInt() % 2;
		
		if (directionToCheck == 0) {
	
			if (! leftIsBlocked()) {
				turnLeft();
				slideOrClimb();
			} else if (! rightIsBlocked()) {
				turnRight();
				slideOrClimb();
			}
			
		} else {
		
			if (! rightIsBlocked()) {
				turnRight();
				slideOrClimb();
			} else if (! leftIsBlocked()) {
				turnLeft();
				slideOrClimb();
			}
		}
	}
	
	public void moveNextPosition() {
	
		if (frontIsClear()) {
			move();
		} else {
			if (facingEast()) {
				turnLeft();
				move();
				turnLeft();
				move();
			} else {
				turnRight();
				move();
				turnRight();
				move();
			}
		}		
	}
	
	public void takeTurn() {
	
		int numMoves = (Math.abs(rnd.nextInt()) % 6) + 1;
		
		int count = 0;
		while (! isFinished() && count < numMoves) {
		
			moveNextPosition();
			count++;
		}
		if (! isFinished() ) {
			checkPosition();
		}
	}
}