/** 
 * Application.java
 *
 * Title:			RobotDemo3
 * Description:		A Robot relay race. Two Robots in one world, with
 *					one beeper. The first robot, finds the beeper, and 
 *					carries it to a place in front of the second robot,
 *					and gets out of the way. The second robot finds the beeper
 *					and carries it two blocks to the East, putting it
 *					down and moving one more block.
 * @author			Don Slater
 * @date			1/8/2003			
 */

package kareltherobot;

public class Application implements Directions {


	// Main entry point
	static public void main(String[] args) {

		Robot Karel = new Robot(3, 1, East, 0);
		Robot Karen = new Robot(1, 1, East, 0);
		
		Karel.move();
		Karel.pickBeeper();
		Karel.turnLeft();
		Karel.turnLeft();
		Karel.turnLeft();
		Karel.move();
		Karel.move();
		Karel.putBeeper();
		Karel.turnLeft();
		Karel.turnLeft();
		Karel.move();
		
		Karen.move();
		Karen.pickBeeper();
		Karen.move();
		Karen.move();
		Karen.putBeeper();
		Karen.move();
				
		
		
		Karel.turnOff();
		Karen.turnOff();
	}
	
	static {
	
		World.readWorld("demo3.txt");
		World.setVisible(true);
		World.setTrace(true);
		World.setDelay(50);
	
	}
}
